/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityControl.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYCONTROL_H__
#define __ENTITYCONTROL_H__

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <rtems.h>
#include <chameleon.h>
#include <panel.h>

#include "EntityProcess.h"
#include "EntityFlash.h"
#include "EntityPanel.h"
#include "EntityMode.h"
#include "EntitySound.h"
#include "EntityGlobal.h"
#include "EntitySynth.h"
#include "EntityDsp.h"
#include "EntityMidi.h"

#include "EntityEditMode.h"
#include "EntitySaveMode.h"
#include "EntityStackMode.h"
#include "EntitySoundMode.h"
#include "EntityGlobalMode.h"
#include "EntitySysexMode.h"
#include "EntityMipsMode.h"
#include "EntityInputMode.h"
#include "EntityOutputMode.h"
#include "EntitySaveGlobalMode.h"
#include "EntityVoiceAssigner.h"
#include "EntitySoundManager.h"

#include "EntityVersion.h"

class EntityControl : public EntityProcess {
				
	EntityFlash* 		flash;
	EntityPanel* 		panel;
	EntityGlobal* 		global;
	EntityMidi* 		midi;
	EntitySynth* 		synth;
	EntityDsp* 		dsp;

	EntitySaveMode*		saveMode;
	EntityEditMode*		editMode;
	EntityStackMode*	stackMode;
	EntitySoundMode* 	soundMode;
	EntityGlobalMode* 	globalMode;
	EntitySysexMode*	sysexMode;
	EntityInputMode*	inputMode;
	EntityOutputMode*	outputMode;
	EntityMipsMode*		mipsMode;
	EntitySaveGlobalMode*	saveGlobalMode;
	
	EntitySoundManager* 	soundManager;	
	ParaStructure*		paras;
	EntityVoiceAssigner*	assign;
	
	void			initialise();
	void			checkFreshInstall();

	void			showPriorityLevels();
	void			showPriority(char*);

	bool 			test();
	bool			testEntitySound();
	bool			testEntityFlash();
	
public:

	static char*		getVersionStr();
	
	void 			Run();
};

#endif /* __ENTITYCONTROL_H__ */
