/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityDefines.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2005						*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYDEFINES_H__
#define __ENTITYDEFINES_H__

//------------------------------------------------------------------------------
// EntitySound.h, EntitySound.cpp
//------------------------------------------------------------------------------

#define SAVE_TO_PRESET 		  	// Print sound data in debug window for copying to preset
//#define SAVE_AS_HUMAN_READABLE  	// Print human-readable sound parameters in debug window 

#define SOUND_BANK_SIZE 40
#define MAX_MATRIX_LINKS 1000

#define SOUND_NAME_LENGTH 16
#define SOUND_TUNING_LENGTH 128
#define SOUND_TUNING_NAME_LENGTH 16
#define MAX_PARANAME_CHARS 32

#define MAX_PARAS_PER_PAGE 16
#define MAX_PAGES_PER_GROUP 10
#define MAX_GROUPS 10

#define MATRIX_MIN -8000
#define MATRIX_MAX 7999

#define DSP_N_CYCLES 64.0
#define DSP_SAMPLE_RATE 48000.0
#define DSP_CLOCK_RATE 100000000.0

#define MAX_NOTE_STACK 6
#define CLEAR_STACK_NOTE -1000

#define MAXIMUM_CASCADE 8
#define N_CASCADE_MODES 8+7+6+5+4+3+2+1
#define N_VOICES_PER_MACHINE 6
#define MAX_VOICES MAXIMUM_CASCADE*N_VOICES_PER_MACHINE
#define POLY_PORTAMENTO_THRESHOLD 100

// Relating to midi

#define N_MIDI_NOTES			 128	// Number of notes
#define N_MIDI_EVENT_TYPES		 256	// See midishare.h
#define ENTITY_SYSEX_MAX_MESSAGE_SIZE	4096	// Max size for Entity
#define SYSEX_FLASH_BUFFER_SIZE	     1048576	// Must be power of two

// Relating to internal events

#define N_SYNTH_EVENT_TYPES 256			// In EntitySynth.cpp
#define NEW_SOUND_WAITS_FOR_NEW_NOTE

//------------------------------------------------------------------------------












#endif /* __ENTITYDEFINES_H__ */

