/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityDsp.h								*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYDSP_H__
#define __ENTITYDSP_H__

#include <rtems.h>
#include <dsp.h>

#include "EntitySound.h"

class EntityDsp {

protected:

	int		dspHandle;
	int		*soundBuffer;
	ParaStructure	*paras;
	
	void		defineBlock(int, int);
public:

	EntityDsp(ParaStructure*);
	~EntityDsp();

	void 	update(int, int);
	void 	update(EntitySound*);
	void	command(int);

	void	writeData(int);
	void	writeData(int*, int);
	void	writeDataBlockX(int, int, int*);
	void	writeDataBlockY(int, int, int*);
	void	writeDataBlockP(int, int, int*);

	int	readData();
	int	readTotalMips();
	int	readFragMips();
	int	readDebugData();
	
	int	readMaxInLevels();
	int	readMaxOutLevels();

	void	waitForDsp();
	void	readyForDsp();
	void	inhibitDsp();
	
	void	minimiseDsp();
	void	maximiseDsp();

	/* Voice commands */
	
	void	voiceAssign(int VDIF, int STDF, int voice);
	void	voiceOn(int pitch, int velocity);	
	void	voiceOnSmooth(int pitch, int velocity);	
	void	voiceShift(int pitch); 
	void	voiceOff(int voice);
	void	voiceMute(int voice);
};

#endif /* __ENTITYDSP_H__ */
