/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityGlobalMode.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYGLOBALMODE_H__
#define __ENTITYGLOBALMODE_H__

#include <rtems.h>
#include <chameleon.h>

#include "EntitySysexMode.h"
#include "EntityGlobal.h"
#include "EntityFlash.h"
#include "EntityMode.h"

#define GLOBAL_SAVE_HOLD_DELAY 200	// Milliseconds before save countdown
#define GLOBAL_SAVE_HOLD_TIME 1000	// Milliseconds to hold down save button
#define LED_BLINK_TIME 240		// Time for half a blink cycle

class EntityGlobalMode : public EntityMode {
	
	EntitySysexMode	*sysexMode;
	EntityGlobal	*global;
	EntityFlash	*flash;	
	GlobalPara	*globalPara;
	
	bool		firstEdit;
	
	bool		parasave;
	int		mp;
	
	Status		incrementValue(int);

	void		displayUpdate();
	void		displayValueUpdate();
	void		autoEvent(int);
	void		save();
	
	void		edit();
	void		editHold();
	void		partUp();
	void		partDown();
	void		pageUp();
	void		pageDown();
	void		paramUp();
	void		paramDown();
	void		valueUp();
	void		valueDown();

	void		shiftParamUp();
	void		shiftParamDown();
	void 		shiftValueUp();
	void		shiftValueDown();
	
	void		editPageDown();

	void		editShift();
	void		pot1Event(int);	

	void		globalParaSave();
	
public:

	Mode		enter();
	
	EntityGlobalMode(EntityPanel*, EntityGlobal*, EntityFlash*, EntitySysexMode*);
};

	








#endif /* __ENTITYGLOBALMODE_H__ */
