/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityMessageHandler.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYMESSAGEHANDLER_H__
#define __ENTITYMESSAGEHANDLER_H__

#include <rtems.h>
#include <chameleon.h>

#define MAX_MESSAGE_SIZE 16

class EntityMessageHandler {

protected:
	
	bool			createQueue(char*, int, int);
	bool			deleteQueue(char*);
	bool			clearQueue(rtems_id);

	rtems_status_code	status;
	char			mBuffer[MAX_MESSAGE_SIZE];

	rtems_name		rtemsName(char*);
	rtems_id		getQueueId(char*);

	int			getMessage(rtems_id);
	int			getMessage(rtems_id, void*);

	int			sendMessage(rtems_id, char);
	int			sendMessage(rtems_id, void*, int=1);

	int			sendUrgentMessage(rtems_id, char);
	int			sendUrgentMessage(rtems_id, void*, int=1);
	
	EntityMessageHandler();
	virtual ~EntityMessageHandler();
};


#endif /* __ENTITYMESSAGEHANDLER_H__ */

