/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityMipsMode.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYMIPSMODE_H__
#define __ENTITYMIPSMODE_H__

#include <rtems.h>
#include <chameleon.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#include "EntityMode.h"
#include "EntityGlobal.h"

class EntityMipsMode : public EntityMode {
	
	EntityRepeat		*repeater;
	EntityGlobal		*global;

	int			getMipsFromMessage();
	void			traceDebugData();

	void			displayUpdate();
	void			displayTotalUpdate();
	void			displayFragUpdate();

	void			autoEvent(int);
	void			partDown();
	void			partUp();
	void			edit();

	int			debugCounter;
	
public:

	Mode			enter();

	EntityMipsMode(EntityPanel*, EntityGlobal*);
};

#endif /* __ENTITYMIPSMODE_H__ */
