/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityProcess.cpp							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004						*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/
  
#include "EntityProcess.h"

static rtems_task run(rtems_task_argument argument) {

	((EntityProcess *) argument)->Run();
}

bool EntityProcess::create(	char* 			taskName, 
				rtems_task_priority 	priority, 
				rtems_unsigned32	stackSize
	) {

	task_mode = 	RTEMS_PREEMPT | 
			RTEMS_TIMESLICE | 
			RTEMS_ASR | 
			RTEMS_INTERRUPT_LEVEL(0);
	
	//TRACE("Task = %s\tpriority = %i\n",taskName,priority);

	status = rtems_task_create(		rtemsName(taskName),
						priority,
						stackSize,
						task_mode,
						RTEMS_DEFAULT_ATTRIBUTES,
						&task_id
	);

	if (status != RTEMS_SUCCESSFUL) {
		
		TRACE("ERROR: cannot create EntityProcess task.\n");
		return false;
	}

	status = rtems_task_start(task_id, run, (rtems_task_argument) this);
	
	if (status != RTEMS_SUCCESSFUL) {
		
		TRACE("ERROR: cannot start EntityProcess::Run.\n");
		return false;
	}

	return true;
}
