/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityRepeat.h								*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYREPEAT_H__
#define __ENTITYREPEAT_H__

#include <rtems.h>

#include "EntityProcess.h"

class EntityRepeat : public EntityProcess {

	rtems_id 	destination_queue_id;
	
	char		pName[5];
	char		qName[5];
	
	char 		message;
	int 		delayTime;
	int 		repeatTime;
	bool		activated;
	
public:

	bool 		create(char*, char*, rtems_task_priority);
	bool		activate(char, int = 0, int = 0);
	bool		running();
	void		wait(int);
	bool		clear();
	void 		Run();
};

#endif /* __ENTITYREPEAT_H__ */
