/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntitySaveMode.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYSAVEMODE_H__
#define __ENTITYSAVEMODE_H__

#include <rtems.h>
#include <chameleon.h>
#include <string.h>

#include "EntitySound.h"
#include "EntityFlash.h"
#include "EntityMode.h"
#include "EntityNameMode.h"

#define SAVE_LED_BLINK_TIME 390

class EntitySaveMode : public EntityMode {
			
	EntitySound*	sound;
	EntityFlash*	flash;
	EntityNameMode* nameMode;
	EntityRepeat*	ledBlinker;
	
	Mode		oldMode;
	int		soundNumber;
	
	int		dp;
	
	void		displayUpdate();
	void		displayValueUpdate();
	Status		incrementValue(int);

	void		blinkSaveLEDs();
	void		autoEvent(int);

	void		edit();
	void		shift();
	void		editHold();
	void		paramUp();
	void		paramDown();
	void		valueUp();
	void		valueDown();

public:

	Mode		enter(EntitySound*, Mode);

	EntitySaveMode(EntityPanel*, EntityFlash*);
	~EntitySaveMode();
};

#endif /* __ENTITYSAVEMODE_H__ */



































