/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntitySoundMode.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYSOUNDMODE_H__
#define __ENTITYSOUNDMODE_H__

#include <rtems.h>
#include <chameleon.h>
#include <string.h>

#include "EntityMode.h"
#include "EntitySoundManager.h"

class EntitySoundMode : public EntityMode {
	
	EntitySoundManager*	soundManager;
	EntityGlobal*		global;
	
	int			number;		// Sound index (ie, 0..n, not modulus bank size)
	int			numberLength;	// Length of sound number on display, ie A13 = 3
	
	Status			incrementValue(int);
	void			midiProgChange();	

	void			displayUpdate();
	void			displayValueUpdate();

	void			displayNewName();
	void			displayBullet();
	void			displayVersionUp();
	
	void			autoEvent(int);

	void			edit();
	void			partUp();
	void			partDown();
	void			pageUp();
	void			pageDown();
	void			paramUp();
	void			paramDown();
	void			valueUp();
	void			valueDown();

	void			buttonOff();
	
public:

	Mode			enter();

	EntitySoundMode(EntityPanel*, EntitySoundManager*, EntityGlobal*);
};

	
	
















#endif /* __ENTITYSOUNDMODE_H__ */
