/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntityStackMode.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYSTACKMODE_H__
#define __ENTITYSTACKMODE_H__

#include <rtems.h>
#include <chameleon.h>

#include <stdio.h>

#include "EntityMode.h"
#include "EntityPanel.h"
#include "EntitySound.h"
#include "EntityGlobal.h"
#include "EntityDefines.h"

class EntityStackMode : public EntityMode {
	
	EntityPanel		*panel;
	ParaStructure		*paras;
	EntitySound		*sound;
	EntityGlobal		*global;
	
	Parameter		*stackParameter;

	void			autoEvent(int);
	void			displayUpdate();
	void			displayValueUpdate();

	void			displayStackNote(int stackNoteNumber);
	
	void			midiNoteOn();
	
	void			edit();
	
	void			partUp();
	void			partDown();
	void			groupUp();
	void			groupDown();
	void			pageUp();
	void			pageDown();
	void			paramUp();
	void			paramDown();
	void			valueUp();
	void			valueDown();

	int			noteCounter;
	int			rootNote;
	
public:

	Mode			enter(EntitySound*);
	
	EntityStackMode(EntityPanel*, EntityGlobal*, ParaStructure*);

};

#endif /* __ENTITYSTACKMODE_H__ */
