/********************************************************************************
 * E N T I T Y 									*
 ********************************************************************************
 * File: EntitySysexMode.h							*
 *                                                                         	*
 * Copyright (C) A.R.Hardie-Bick 2004-2005					*
 *										*
 * This program is free software; you can redistribute it and/or modify		*
 * it under the terms of the GNU General Public License as published by		*
 * the Free Software Foundation; either version 2 of the License, or (at	*
 * your option) any later version.						*
 *										*
 * This program is distributed in the hope that it will be useful, but		*
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
 * General Public License for more details.					*
 *										*
 * You should have received a copy of the GNU General Public License		*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
 *******************************************************************************/

#ifndef __ENTITYSYSEXMODE_H__
#define __ENTITYSYSEXMODE_H__

#include "EntityMode.h"
#include "EntityMidi.h"
#include "EntityFlash.h"
#include "EntityGlobal.h"
#include "EntityMessages.h"
#include "EntitySoundManager.h"

class EntitySysexMode : public EntityMode {
	
	EntityMidi		*midi;
	EntityFlash		*flash;
	EntityGlobal		*global;
	EntitySoundManager	*soundManager;
	
	void			displayUpdate();
	
	void			loadFlashSoundFromMidi();
	void			loadEditedSoundFromMidi();
	void			loadFlashGlobalFromMidi();
	void			loadEditedGlobalFromMidi();
	void			loadTuningFromMidi();
	
	int			loadMidiBufferIn();
	
	void			autoExit();
	void			waitForMidi(int nBytes);
	
	unsigned char		midiBufferIn[ENTITY_SYSEX_MAX_MESSAGE_SIZE];
	unsigned char		midiBufferOut[ENTITY_SYSEX_MAX_MESSAGE_SIZE];

public:

	int			saveSoundToMidi(bool);
	int			saveSoundToMidi(int, bool);
	int			saveActiveSoundToMidi(bool);
	int			saveGlobalToMidi(bool);
	
	void			saveBankToMidi();
	void			saveCurrentBankToMidi();
	void			saveAllSoundsToMidi();
	void			saveAllToMidi();

	Mode			enter();
	
	EntitySysexMode(EntityPanel*, EntityMidi*, EntityFlash*, EntityGlobal*, EntitySoundManager*);
};

#endif /* __ENTITYSYSEXMODE_H__ */
