;********************************************************************************
;* E N T I T Y 									*
;********************************************************************************
;* File: dsp/main.asm								*
;*                                                                         	*
;* Top level structure for 56K code.						*
;* 										*
;* Copyright (C) A.R.Hardie-Bick 2004-2005                                      *
;*										*
;* This program is free software; you can redistribute it and/or modify		*
;* it under the terms of the GNU General Public License as published by		*
;* the Free Software Foundation; either version 2 of the License, or (at	*
;* your option) any later version.						*
;*										*
;* This program is distributed in the hope that it will be useful, but		*
;* WITHOUT ANY WARRANTY; without even the implied warranty of			*
;* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU		*
;* General Public License for more details.					*
;*										*
;* You should have received a copy of the GNU General Public License		*
;* along with this program; if not, write to the Free Software			*
;* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.			*
;********************************************************************************

	page	255,0
	opt	MU,S,CC,CEX,MEX,MD

;--------------------------------------------------------------------------------
; 	Data
;--------------------------------------------------------------------------------

	include 'lut.asm'
	include 'macro.asm'
	include 'sound.asm'
	include 'memory.asm'
	include	'relative.asm'
	include	'dsp_equ.asm'

;--------------------------------------------------------------------------------
; 	Program
;--------------------------------------------------------------------------------

	org	P(1):$000100		; On chip program memory (up to 1K)
	org	P(2):$400000		; Off chip program memory (1K cached)

	include 'interrupts.asm'
	include	'initialise.asm'

	org	P(2):

MainLoop

	MOVE	Y:sGenVector,R0			; Get sound generation vector
	BCHG	#skipCodeFragment,Y:flags	; Alternately include and exclude measured code fragment (if any)
	ORI	#$03,MR				; Disable interrupts for data atomicity at start of parameterGenerator

	JMP	(R0)				; ParameterGenerator, FadeSoundQuickly, TransferNewSound

	include 'parameterGenerator.asm'
	include 'sampleGenerator.asm'

;--------------------------------------------------------------------------------

